//////////////////////////////////////////////////
// Programmierer:	Sascha Kurz		//
// Programmname:	Brutal-Force.cpp	//
// zuletzt getestet:	25.09.01		//
// Betriebssysteme:	DOS			//
// Sinn und Zweck:	Scanning von 		//
//			Persistencen mittels 	//
//			Brutal-Force		//
// Kontakt:		KurzTEF@web.de		//
//			http://www.stud.uni-	//
//			bayreuth.de/~a8581	//	
//////////////////////////////////////////////////

#include <iostream>
#include <math.h>
#include <iomanip>

int persistence(long n,int b)
{
  int r=0;
  if(n<b) return r;	// Ist bereits eine einstellige Zahl
  long m1,m2;
  m1=n;
  int f;
  while(m1>=b)
  {
    m2=1;
    while(m1>=b)
    {
      f=m1%b;
      m2*=f;
      m1=(m1-f)/b;  
    };   
    m2*=m1;
    r++;
    m1=m2;
  };
  return r;
};

int main(void)
{
  long min[100];
  long i; 
  long grenze;
  int basis;
  int p;
  for(p=0;p<100;p++)
    min[p]=-1;
  cout << "Berechnung von minimalen Zahlen mit Persistence p mittels Brutal-Force" << endl;
  cout << endl;
  cout << "Geben Sie die Basis ein:";
  cin  >> basis;
  cout << "Geben Sie die obere Grenze ein:";
  cin  >> grenze;
  grenze=30200000;
  for(i=0;i<=grenze;i++)
  {
    p=persistence(i,basis);
    if(min[p]==-1)
    {
      min[p]=i;
      cout << p << " : " << i << endl;   
    };
  };
  return 0;
};
