//////////////////////////////////////////////////
// Programmierer:	Sascha Kurz		//
// Programmname:	reihe.cpp		//
// zuletzt getestet:	28.09.01		//
// Betriebssysteme:	DOS			//
//                      Linux                   //
// Sinn und Zweck:	Berechnung der Reihe der//
//			kleinsten Zahlen mit    //
//			Persistence p		//
// Kontakt:		KurzTEF@web.de		//
//			http://www.stud.uni-	//
//			bayreuth.de/~a8581	//	
//////////////////////////////////////////////////

#include <iostream>
#include <iomanip>

int persistence(int zahl, int basis)
{
  if(zahl<basis) return 0;
  int hilf=1;
  int speicher;
  while(zahl>=basis)
  {
    speicher=zahl-((int)(zahl/basis))*basis;
    hilf*=speicher;
    zahl=(zahl-speicher)/basis;
  };
  speicher=zahl-((int)(zahl/basis))*basis;
  hilf*=speicher;
  zahl=(zahl-speicher)/basis;
  return persistence(hilf,basis)+1;
};

int main(void)
{
  int i;
  int anfang;
  int grenze;
  bool erreicht;
  int pers;
  cout << "Geben Sie die Persistence ein:";
  cin  >> pers;
  cout << "Geben Sie den Anfang ein:";
  cin  >> anfang;
  cout << "Geben Sie die Grenze ein:";
  cin  >> grenze;
  int e;
  int fak=1;
  for(i=1;i<=pers;i++)
    fak*=i;
  for(i=anfang;i<=grenze;i++)
  {
    erreicht=false;
    e=0;
    e=(pers+1)*i-int(i/fak)-1;
    while(erreicht==false)
    {
      if(persistence(e,i)==pers)
      {
        cout << i << " : " << e;
        if(e==(pers+1)*i-int(i/fak)) cout << " Formel ";
        cout << endl;
        erreicht=true;
      };
      e++;
    };
  };
  return 0;
};

