//////////////////////////////////////////////////
// Programmierer:	Sascha Kurz		//
// Programmname:	persistence3.cpp	//
// zuletzt getestet:	28.09.01		//
// Betriebssysteme:	DOS			//
//                      Linux                   //
// Sinn und Zweck:	Testen der letzen 	//
//			Stellen von 2^n in der 	//
//			Basis 3			//
// Bisher erreicht:	- p(n,3)<=3 fr alle	//
//			n<=2^10^10	        //
//			- MaxZiffer=??		//
// Kontakt:		KurzTEF@web.de		//
//			http://www.stud.uni-	//
//			bayreuth.de/~a8581	//	
//////////////////////////////////////////////////

#include <iostream>
#include <fstream>
#include <iomanip>

int main(void)
{
  ofstream file1;	
  ifstream file2;
  ofstream file3;
  int s1,s2,s3,nummer;
  char* name;
  name=new char[10];
  const long anzahl=300000000;
  double start;
  const int hinten=100;
  int vektor[hinten+2];
  int f;
  int i;
  int max=0;
  double e=0;
  bool zero;
  char taste;

  nummer=-1;
  while(true)
  {
  nummer++;
  cout << "[" << nummer << "]" << endl;

  file2.open("persistence_basis3");								
  if(file2.fail())									
  {
    cout << "Fehler beim Oeffnen des Files." << endl;
    return -1;
  };
  file2 >> start;
  for(i=0;i<=hinten;i++)
    file2 >> vektor[i];
  file2.close();
  vektor[hinten+1]=0;
  e=start;
  for(f=0;f<anzahl;f++)
  {
    e=e++;
    //if(f%(int)(anzahl/100)==0) cout << (int) (f*100.0/anzahl) << " %" << endl;
    for(i=0;i<=hinten;i++)
      vektor[i]*=2;
    for(i=0;i<=hinten;i++)
      if(vektor[i]>2)
      {
        vektor[i]-=3;
        vektor[i+1]++;
      };
    vektor[hinten+1]=0;
    zero=false;
    for(i=0;i<=hinten;i++)
      if(vektor[i]==0)
      {
        zero=true;
        if(i>max)
        {
          max=i;
          cout << "Max:  " << max << endl;
        };
        i=hinten;
      };
    if(zero==false)
    {
      cout << e << endl;
      cin  >> taste;
    };
  };
  file1.open("persistence_basis3");								
  if(file1.fail())									
  {
    cout << "Fehler beim Oeffnen des Files." << endl;
    return -1;
  };
  file1 << setprecision(14) << e << endl;
  for(i=0;i<=hinten;i++)
    file1 << vektor[i] << " ";
  cout << "Fertig:  " << setprecision(14) << e << endl;
  cout << "Max:  " << max << endl;
  file1.close();


  name[0]='p';
  name[1]='_';
  name[2]='3';
  name[3]='_';
  s1=nummer%26;
  s3=((nummer-s1)/26);
  s2=s3%26;
  s3=(s3-s2)/26;
  name[4]=s3+65;
  name[5]=s2+65;
  name[6]=s1+65;
  name[7]='\0';
  file3.open(name);
  if(file3.fail())									
  {
    cout << "Fehler beim Oeffnen des Files." << endl;
    return -1;
  };
  file3 << setprecision(14) << e << endl;
  for(i=0;i<=hinten;i++)
    file3 << vektor[i] << " ";
  file3.close();
  }
  return 0;
};

