//////////////////////////////////////////////////
// Programmierer:	Sascha Kurz		//
// Programmname:	pers_12.cpp		//
// zuletzt getestet:	28.09.01		//
// Betriebssysteme:	DOS			//
//                      Linux                   //
// Sinn und Zweck:	Scanning von 		//
//			Persistencen in der 	//
//			Basis 9			//
// Bisher erreicht:	- p(n,9)<=7 fr alle	//
//			n<=10^953		//
//			- Potenenzsumme>1000    //
//			- MaxZiffer=60		//
//                      - Rechenzeit=49:57 min  //
// Kontakt:		KurzTEF@web.de		//
//			http://www.stud.uni-	//
//			bayreuth.de/~a8581	//	
//////////////////////////////////////////////////

#include <iostream>

inline int min(int a,int b)
{
  if(a<b) return a;
  return b;
};

int main(void)			// Hauptprogramm
{
  // Fr Basis 9
  // Fuer mehr Kommentare bitte im Referenzfile pers_11.cpp
  // nachschauen. Die Struktur stimmt ueberein.	

  const int anzahl=80;
  const int bisher=100;
  const int basis=9;
  int g;
  bool zero;
  int threes;
  int u;
  int summe;
  const int parameter1=8;
  const int parameter2=7;
  const int parameter3=5;
  const int parameter4=2;
  const int parameter5=3;
  int position1,position2,position3,position4,position5;
  int zahl1[anzahl+2], zahl2[anzahl+2],zahl3[anzahl+2],zahl4[anzahl+2],zahl5[anzahl+2];
  int a,b,c,d,e;
  int i;
  int max=0;
  char taste;

  cout << "Persistence of a number" << endl;
  cout << "=======================" << endl << endl;
  cout << "Basis : " << basis << endl;
  cout << "Geben Sie die Potenzsumme ein:";
  cin  >> summe;

  // #######################################################################
  // #                   erster Durchlauf                                  #
  // #######################################################################
  for(i=0;i<=anzahl;i++)
  {
    zahl1[i]=0;
    zahl2[i]=0;
    zahl3[i]=0;
    zahl4[i]=0;
    zahl5[i]=0; 
  };  
  zahl1[0]=1;
  position1=0;
  position2=0;
  position3=0;
  position4=0;
  position5=0;
  for(a=0;a<=summe;a++)
  {
    cout << "[1] " << a << endl;
    if(a>0)
    {
      g=min(position1,anzahl);
      for(i=0;i<=g;i++)
        zahl1[i]*=parameter1;
      for(i=0;i<=g;i++)
      {
        u=zahl1[i]/basis;
        zahl1[i]-=u*basis;
        zahl1[i+1]+=u;
      };
      if(position1<anzahl) if(zahl1[position1+1]>0) position1++;
      if(a>bisher)
      {
        g=min(position1,anzahl);
        zero=false;
        threes=0;
        for(i=0;i<=g;i++)
        {
          if((zahl1[i]%3)==0) threes++;
          if(zahl1[i]==0 || threes>1)
          {
            zero=true;
            if(i>max)max=i;
            break;
          };
        };
        if(zero==false)
        {
          cout << "(" << a << ",0,0)" << endl;
          cin  >> taste;
        };
      };
    };
    position2=position1;
    g=min(position1,anzahl);
    for(i=0;i<=g;i++)
      zahl2[i]=zahl1[i];
    for(i=position1+1;i<=anzahl;i++)
      zahl2[i]=0;
    for(b=0;b<=summe-a;b++)
    {
      if(b>0)
      {
        g=min(position2,anzahl);
        for(i=0;i<=g;i++)
          zahl2[i]*=parameter2;
        for(i=0;i<=g;i++)
        {
          u=zahl2[i]/basis;
          zahl2[i]-=u*basis;
          zahl2[i+1]+=u;
        };
        if(position2<anzahl) if(zahl2[position2+1]>0) position2++;
        if(a+b>bisher)
        {
          g=min(position2,anzahl);
          zero=false;
          threes=0;
          for(i=0;i<=g;i++)
          {
            if((zahl2[i]%3)==0) threes++;
            if(zahl2[i]==0 || threes>1)
            {
             zero=true;
              if(i>max)max=i;
              break;
            };
          };
          if(zero==false)
          {
            cout << "(" << a << "," << b << ",0)" << endl;
            cin  >> taste;
          };
        };
      };
      position3=position2;
      g=min(position2,anzahl);
      for(i=0;i<=g;i++)
        zahl3[i]=zahl2[i];
      for(i=position2+1;i<=anzahl;i++)
        zahl3[i]=0;
      for(c=0;c<=summe-a-b;c++)
      {
        if(c>0)
        {
          g=min(position3,anzahl);
          for(i=0;i<=g;i++)
            zahl3[i]*=parameter3;
          for(i=0;i<=g;i++)
          {
            u=zahl3[i]/basis;
            zahl3[i]-=u*basis;
            zahl3[i+1]+=u;
          };
          if(position3<anzahl) if(zahl3[position3+1]>0) position3++;
          if(a+b+c>bisher)
          {
            g=min(position3,anzahl);
            zero=false;
            threes=0;
            for(i=0;i<=g;i++)
            {
              if((zahl3[i]%3)==0) threes++;
              if(zahl3[i]==0 || threes>1)
              {
                zero=true;
                if(i>max)max=i;
                break;
              };
            };
            if(zero==false)
            {
              cout << "(" << a << "," << b << "," << c << ")" << endl;
              cin  >> taste;
            };
          };
        };
        if(a+b+c>bisher)
        {
          position4=position3;
          g=min(position3,anzahl);
          for(i=0;i<=g;i++)
            zahl4[i]=zahl3[i];
          for(i=position3+1;i<=anzahl;i++)
            zahl4[i]=0;
          for(d=0;d<=2;d++)
          {
            if(d>0)
            {
              g=min(position4,anzahl);
              for(i=0;i<=g;i++)
                zahl4[i]*=parameter4;
              for(i=0;i<=g;i++)
              {
                u=zahl4[i]/basis;
                zahl4[i]-=u*basis;
                zahl4[i+1]+=u;
              };
              if(position4<anzahl) if(zahl4[position4+1]>0) position4++;
              g=min(position4,anzahl);
              zero=false;
              threes=0;
              for(i=0;i<=g;i++)
              {
                if((zahl4[i]%3)==0) threes++;
                if(zahl4[i]==0 || threes>1)
                {
                  zero=true;
                  if(i>max)max=i;
                  break;
                };
              };
              if(zero==false)
              {
                cout << "(" << a << "," << b << "," << c << ") * ";
                if(d==1) cout << parameter4; else cout << parameter4*parameter4;
                cout << endl;
                cin  >> taste;
              };
            };
            position5=position4;
            g=min(position5,anzahl);
            for(i=0;i<=g;i++)
              zahl5[i]=zahl4[i];
            for(i=position4+1;i<=anzahl;i++)
              zahl5[i]=0;
            e=1;
            for(i=0;i<=g;i++)
              zahl5[i]*=parameter5;
            for(i=0;i<=g;i++)
            {
              u=zahl5[i]/basis;
              zahl5[i]-=u*basis;
              zahl5[i+1]+=u;
            };
            if(position5<anzahl) if(zahl5[position5+1]>0) position5++;
            g=min(position5,anzahl);
            zero=false;
            threes=0;
            for(i=0;i<=g;i++)
            {
              if((zahl5[i]%3)==0) threes++;
              if(zahl5[i]==0 || threes>1)
              {
                zero=true;
                if(i>max)max=i;
                break;
              };
            };
            if(zero==false)
            {
              cout << "(" << a << "," << b << "," << c << ") * ";
              if(d==1) cout << parameter4*parameter5; else cout << parameter4*parameter4*parameter5;
              cout << endl;
              cin  >> taste;
            };
          };
        };
      };
    };
  };
  
  cout << "Maximale Ziffer ohne Null : " << max << endl;
  return 0;
};

