//////////////////////////////////////////////////
// Programmierer:	Sascha Kurz		//
// Programmname:	pers_14.cpp		//
// zuletzt getestet:	28.09.01		//
// Betriebssysteme:	DOS			//
//                      Linux                   //
// Sinn und Zweck:	Scanning von 		//
//			Persistencen in der 	//
//			Basis 7			//
// Bisher erreicht:	- p(n,7)<=8 fr alle	//
//			n<=10^844		//
//			- Potenenzsumme>1000	//
//			- Maxziffer=144		//
// 			- Rechenzeit=42:32 min  //
// Kontakt:		KurzTEF@web.de		//
//			http://www.stud.uni-	//
//			bayreuth.de/~a8581	//	
//////////////////////////////////////////////////

#include <iostream>

inline int min(int a,int b)
{
  if(a<b) return a;
  return b;
};

int main(void)			// Hauptprogramm
{
  // Fr Basis 7
  // Fuer mehr Kommentare bitte im Referenzfile pers_11.cpp
  // nachschauen. Die Struktur stimmt ueberein.	

  const int anzahl=200;
  int u;
  int g;
  const int bisher=1000;
  const int basis=7;
  int summe;
  bool zero;
  int parameter1=5;
  int parameter2=4;
  int parameter3=3;
  int parameter4=2;
  int position1,position2,position3,position4;
  int zahl1[anzahl+2], zahl2[anzahl+2],zahl3[anzahl+2],zahl4[anzahl+2];
  int a,b,c,d;
  int i;
  int max=0;
  char taste;

  cout << "Persistence of a number" << endl;
  cout << "=======================" << endl << endl;
  cout << "Basis : " << basis << endl;
  cout << "Geben Sie die Potenzsumme ein:";
  cin  >> summe;

  // #######################################################################
  // #                   erster Durchlauf                                  #
  // #######################################################################
  for(i=0;i<=anzahl;i++)
  {
    zahl1[i]=0;
    zahl2[i]=0;
    zahl3[i]=0;
    zahl4[i]=0;
  };  
  zahl1[0]=1;
  position1=0;
  position2=0;
  position3=0;
  position4=0;
  for(a=0;a<=summe;a++)
  {
    cout << "[1] " << a << endl;
    if(a>0)
    {
      g=min(position1,anzahl);
      for(i=0;i<=g;i++)
        zahl1[i]*=parameter1;
      for(i=0;i<=g;i++)
      {
        u=zahl1[i]/basis;
        zahl1[i]-=u*basis;
        zahl1[i+1]+=u;
      };
      if(position1<anzahl) if(zahl1[position1+1]>0) position1++;
      if(a>bisher)
      {
        g=min(position1,anzahl);
        zero=false;
        for(i=0;i<=g;i++)
        {
          if(zahl1[i]==0)
          {
            zero=true;
            if(i>max) max=i;
            break;
          };
        };
        if(zero==false)
        {
          cout << "(" << a << ",0,0)" << endl;
          cin  >> taste;
        };
      };
    };
    position2=position1;
    g=min(position1,anzahl);
    for(i=0;i<=g;i++)
      zahl2[i]=zahl1[i];
    for(i=position1+1;i<=anzahl;i++)
      zahl2[i]=0;
    for(b=0;b<=summe-a;b++)
    {
      if(b>0)
      {
        g=min(position2,anzahl);
        for(i=0;i<=g;i++)
          zahl2[i]*=parameter2;
        for(i=0;i<=g;i++)
        {
          u=zahl2[i]/basis;
          zahl2[i]-=u*basis;
          zahl2[i+1]+=u;
        };
        if(position2<anzahl) if(zahl2[position2+1]>0) position2++;
        if(a+b>bisher)
        {
          g=min(position2,anzahl);
          zero=false;
          for(i=0;i<=g;i++)
          {
            if(zahl2[i]==0)
            {
              zero=true;
              if(i>max) max=i;
              break;
            };
          };
          if(zero==false)
          {
            cout << "(" << a << "," << b << ",0)" << endl;
            cin  >> taste;
          };
        };
      };
      position3=position2;
      g=min(position2,anzahl);
      for(i=0;i<=g;i++)
        zahl3[i]=zahl2[i];
      for(i=position2+1;i<=anzahl;i++)
        zahl3[i]=0;
      for(c=0;c<=summe-a-b;c++)
      {
        if(c>0)
        {
          g=min(position3,anzahl);
          for(i=0;i<=g;i++)
            zahl3[i]*=parameter3;
          for(i=0;i<=g;i++)
          {
            u=zahl3[i]/basis;
            zahl3[i]-=u*basis;
            zahl3[i+1]+=u;
          };
          if(position3<anzahl) if(zahl3[position3+1]>0) position3++;
          if(a+b+c>bisher)
          {
            g=min(position3,anzahl);
            zero=false;
            for(i=0;i<=g;i++)
            {
              if(zahl3[i]==0)
              {
                zero=true;
                if(i>max) max=i;
                break;
              };
            };
            if(zero==false)
            {
              cout << "(" << a << "," << b << "" << c <<")" << endl;
              cin  >> taste;
            };
          };
        };
        if(a+b+c>bisher)
        {
          position4=position3;
          g=min(position4,anzahl);
          for(i=0;i<=g;i++)
            zahl4[i]=zahl3[i];
          for(i=position3+1;i<=anzahl;i++)
            zahl4[i]=0;
          for(d=1;d<=1;d++)
          {
            for(i=0;i<=g;i++)
              zahl4[i]*=parameter4;
            for(i=0;i<=g;i++)
            {
              u=zahl4[i]/basis;
              zahl4[i]-=u*basis;
              zahl4[i+1]+=u;
            };
            if(position4<anzahl) if(zahl4[position4+1]>0) position4++;
            g=min(position4,anzahl);
            zero=false;
            for(i=0;i<=g;i++)
            {
              if(zahl4[i]==0)
              {
                zero=true;
                if(i>max) max=i;
                break;
              };
            };
            if(zero==false)
            {
              cout << "(" << a << "," << b << "," << c <<") * " << parameter4 << endl;
              cin  >> taste;
            };
          };
        };
      };
    };
  };

  cout << "Maximale Ziffer ohne Null : " << max << endl;
  return 0;
};

