//////////////////////////////////////////////////
// Programmierer:	Sascha Kurz		//
// Programmname:	pers_16.cpp		//
// zuletzt getestet:	28.09.01		//
// Betriebssysteme:	DOS			//
//                      Linux                   //
// Sinn und Zweck:	Scanning von 		//
//			Persistencen in der 	//
//			Basis 5			//
// Bisher erreicht:	- p(n,5)<=6 fr alle	//
//			n<=10^6988              //
//			- Potenenzsumme>10000	//
//                      - Rechenzeit=22:45 min  //
//			- Maxstelle=83		//
// Kontakt:		KurzTEF@web.de		//
//			http://www.stud.uni-	//
//			bayreuth.de/~a8581	//	
//////////////////////////////////////////////////

#include <iostream>

inline int min(int a,int b)
{
  if(a<b) return a;
  return b;
};


int main(void)			// Hauptprogramm
{
  // Fr Basis 5
  // Fuer mehr Kommentare bitte im Referenzfile pers_11.cpp
  // nachschauen. Die Struktur stimmt ueberein.	

  const int anzahl=120;
  int u;
  int g;
  const int bisher=10000;
  int basis;
  int summe;
  int parameter1=4;
  int parameter2=3;
  int parameter3=2;
  int position1,position2,position3;
  int zahl1[anzahl+2], zahl2[anzahl+2],zahl3[anzahl+2];
  int a,b;
  int i;
  bool zero;
  int max=0;
  char taste;


  cout << "Persistence of a number" << endl;
  cout << "=======================" << endl << endl;
  cout << "Basis : 5" << endl;
  basis=5;
  cout << "Geben Sie die Potenzsumme ein:";
  cin  >> summe;



  // #######################################################################
  // #                   erster Durchlauf                                  #
  // #######################################################################
  for(i=0;i<=anzahl;i++)
  {
    zahl1[i]=0;
    zahl2[i]=0;
    zahl3[i]=0;
  };
  zahl1[0]=1;
  position1=0;
  position2=0;
  position3=0;
  for(a=0;a<=summe;a++)
  {
    cout << "[1] " << a << endl;
    if(a>0)
    {
      g=min(position1,anzahl);
      for(i=0;i<=g;i++)
        zahl1[i]*=parameter1;
      for(i=0;i<=g;i++)
      {
        u=zahl1[i]/basis;
        zahl1[i]-=u*basis;
        zahl1[i+1]+=u;
      };
      if(position1<anzahl) if(zahl1[position1+1]>0) position1++;
      if(a>bisher)
      {
        g=min(position1,anzahl);
        zero=false;
        for(i=0;i<=g;i++)
        {
          if(zahl1[i]==0)
          {
            zero=true;
            if(i>max) max=i;
            break;
          };
        };
        if(zero==false)
        {
          cout << "(" << a << ",0)" << endl;
          cin  >> taste;
        };
      };
    };
    position2=position1;
    g=min(position1,anzahl);
    for(i=0;i<=g;i++)
      zahl2[i]=zahl1[i];
    for(i=position1+1;i<=anzahl;i++)
      zahl2[i]=0;
    for(b=0;b<=summe-a;b++)
    {
      if(b>0)
      {
        g=min(position2,anzahl);
        for(i=0;i<=g;i++)
          zahl2[i]*=parameter2;
        for(i=0;i<=g;i++)
        {
          u=zahl2[i]/basis;
          zahl2[i]-=u*basis;
          zahl2[i+1]+=u;
        };
        if(position2<anzahl) if(zahl2[position2+1]>0) position2++;
        if(a+b>bisher)
        {
          g=min(position2,anzahl);
          zero=false;
          for(i=0;i<=g;i++)
          {
            if(zahl2[i]==0)
            {
              zero=true;
              if(i>max) max=i;
              break;
            };
          };
          if(zero==false)
          {
            cout << "(" << a << "," << b << ")" << endl;
            cin  >> taste;
          };
        };
      };
      if(a+b>bisher)
      {
        position3=position2;
        g=min(position2,anzahl);
        for(i=0;i<=g;i++)
          zahl3[i]=zahl2[i];
        for(i=position2+1;i<=anzahl;i++)
          zahl3[i]=0;
        g=min(position3,anzahl);
        for(i=0;i<=g;i++)
          zahl3[i]*=parameter3;
        for(i=0;i<=g;i++)
        {
          u=zahl3[i]/basis;
          zahl3[i]-=u*basis;
          zahl3[i+1]+=u;
        };
        if(position3<anzahl) if(zahl3[position3+1]>0) position3++;
        g=min(position3,anzahl);
        zero=false;
        for(i=0;i<=g;i++)
        {
          if(zahl3[i]==0)
          {
            zero=true;
            if(i>max) max=i;
            break;
          };
        };
        if(zero==false)
        {
          cout << "(" << a << "," << b << ") * 2" << endl;
          cin  >> taste;
        };
      };
    };
  };

  cout << "Maximale Stelle ohne Null : " << max << endl;
  return 0;
};

