//////////////////////////////////////////////////
// Programmierer:	Sascha Kurz		//
// Programmname:	persistence4.cpp	//
// zuletzt getestet:	28.09.01		//
// Betriebssysteme:	DOS			//
//                      Linux                   //
// Sinn und Zweck:	Testen der letzen 	//
//			Stellen von 3^n (*2) in	//
//			der Basis 4		//
// Bisher erreicht:	- p(n,4)<=3 fr alle	//
//			n<=3^(2*10^9)	        //
//			- MaxZiffer=30		//
// Kontakt:		KurzTEF@web.de		//
//			http://www.stud.uni-	//
//			bayreuth.de/~a8581	//	
//////////////////////////////////////////////////

#include <iostream>
#include <iomanip>
#include <fstream>

int main(void)
{
  int a;
  const int anzahl=50;
  ofstream file1;	
  ifstream file2;
  ofstream file3;
  int s1,s2,s3,nummer;
  char* name;
  name=new char[10];
  int vektor[anzahl+2];
  int vektor2[anzahl+2];
  double e;
  int i;
  double start;
  int summe=0;
  bool zero;
  int twos;
  char taste;
  int max=0;
  cout << "Persistence of a number" << endl;
  cout << "-----------------------" << endl << endl;
  cout << "Hier: Basis 4" << endl;
  cout << "Geben Sie die Exponentensumme ein:";
  summe=100000000;
  cout << summe << endl;
  //cin  >> summe;

  nummer=-1;
  while(true)
  {
  nummer++;
  cout << "[" << nummer << "]" << endl;

  file2.open("persistence_basis4");								
  if(file2.fail())									
  {
    cout << "Fehler beim Oeffnen des Files." << endl;
    return -1;
  };
  file2 >> start;
  for(i=0;i<=anzahl;i++)
    file2 >> vektor[i];
  file2.close();
  vektor[anzahl+1]=0;
  e=start;
  for(a=1;a<=summe;a++)
  {
    e++;
    //if(a%(int)(summe/100)==0) cout << (int) (a*100.0/summe) << " %" << endl;
    for(i=0;i<=anzahl;i++)
      vektor[i]*=3;
    for(i=0;i<=anzahl;i++)
      if(vektor[i]>3)
      {
        vektor[i+1]++;
        vektor[i]-=4;
        if(vektor[i]>3)
        {
          vektor[i+1]++;
          vektor[i]-=4;
        };
      };
    zero=false;
    twos=0;
    for(i=0;i<=anzahl;i++)
    {
      if(vektor[i]==2) twos++;
      if(vektor[i]==0 || twos>=2)
      {
        zero=true;
        if(i>max)
        {
          max=i;
          cout << "Max: " << max << endl;
        };
        i=anzahl;
      };
    };
    if(zero==false)
    {
      cout << "(" << a+start << ",0)" << endl;
      cin  >> taste;
    };
    for(i=0;i<=anzahl;i++)
      vektor2[i]=2*vektor[i];
    for(i=0;i<=anzahl;i++)
      if(vektor2[i]>3)
      {
        vektor2[i+1]+=(vektor2[i]-(vektor2[i]%4))/4;
        vektor2[i]=vektor2[i]%4;
      };
    zero=false;
    twos=0;
    for(i=0;i<=anzahl;i++)
    {
      if(vektor2[i]==2) twos++;
      if(vektor2[i]==0 || twos>=2)
      {
        zero=true;
        if(i>max)
        {
          max=i;
          cout << "Max: " << max << endl;
        };
        i=anzahl;
      };
    };
    if(zero==false)
    {
      cout << "(" << a+start << ",1)" << endl;
      cin  >> taste;
    };
  };
  cout << "Fertig:  " << setprecision(14) << e << endl;
  cout << "Max:  " << max << endl;
  file1.open("persistence_basis4");
  if(file1.fail())									
  {
    cout << "Fehler beim Oeffnen des Files." << endl;
    return -1;
  };
  file1 << setprecision(14) << e << endl;
  for(i=0;i<=anzahl;i++)
    file1 << vektor[i] << " ";
  file1.close();

  name[0]='p';
  name[1]='_';
  name[2]='4';
  name[3]='_';
  s1=nummer%26;
  s3=((nummer-s1)/26);
  s2=s3%26;
  s3=(s3-s2)/26;
  name[4]=s3+65;
  name[5]=s2+65;
  name[6]=s1+65;
  name[7]='\0';
  file3.open(name);
  if(file3.fail())									
  {
    cout << "Fehler beim Oeffnen des Files." << endl;
    return -1;
  };
  file3 << setprecision(14) << e << endl;
  for(i=0;i<=anzahl;i++)
    file3 << vektor[i] << " ";
  file3.close();

  };

  return 0;
};

